"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const Sandy = props => {
  const [isKeyboardVisible, setKeyboardVisible] = (0, _react.useState)(false);
  const [modalVisible, setModalVisible] = (0, _react.useState)(props.modalVisible || false);
  const [timerCount, setTimer] = (0, _react.useState)(0);
  (0, _react.useEffect)(() => {
    const keyboardDidShowListener = _reactNative.Keyboard.addListener('keyboardDidShow', () => {
      setKeyboardVisible(true); // or some other action
    });

    const keyboardDidHideListener = _reactNative.Keyboard.addListener('keyboardDidHide', () => {
      setKeyboardVisible(false); // or some other action
    });

    return () => {
      keyboardDidHideListener.remove();
      keyboardDidShowListener.remove();
    };
  }, []);
  (0, _react.useEffect)(() => {
    timerValue();
  }, [props.modalVisible]);
  const timerValue = () => {
    if (props.modalVisible == true) {
      let timeval = 31;
      let testTime = setInterval(function () {
        setTimer(--timeval);
        if (timeval == 0) {
          clearInterval(testTime);
        }
      }, 1000);
    } else {
      console.log('not time');
    }
  };
  console.log('isKeyboardVisible', isKeyboardVisible);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactNative.SafeAreaView, {
    style: {
      flex: 1
    }
  }, /*#__PURE__*/_react.default.createElement(_reactNative.KeyboardAvoidingView, {
    behavior: _reactNative.Platform.OS == 'android' ? 'height' : 'padding'
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [{
      height: '100%',
      width: '100%'
      // justifyContent: 'center',
    }, props.MainView]
  }, props.source ? /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [{
      // height: isKeyboardVisible ? '40%' : '60%',
      width: '90%',
      alignSelf: 'center'
    }, props.ImageViewStyle]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
    source: props.source ? props.source : require('./a.jpeg'),
    style: [styles.backgroundImage, {
      height: 50,
      width: 230
    }, props.ImageStyle]
  })) : null, props.modalVisible ? null : /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [styles.viewa, props.ContainerViewStyle]
  }, /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.Logintitle, props.TextStyle]
  }, props.Login || 'Login'), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.Texttitle, props.TexttitleStyle]
  }, props.Texttitle || 'Build your ideas into future ready digital apps'), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.RegisterText, props.RegisterTextStyle]
  }, props.RegisterText || "If you don't have an account register, You can ", /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.RegisterText, props.RegisterTextStyle, {
      color: 'blue',
      fontWeight: '600'
    }]
  }, "Register here!")), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.inputContainer
  }, /*#__PURE__*/_react.default.createElement(_reactNative.TextInput, {
    numberOfLines: props.numberOfLines || 1,
    maxLength: props.maxLength || 10,
    onChangeText: props.onChangeText,
    value: props.value,
    style: [styles.input, props.InputBoxStyle],
    returnKeyType: props.returnKeyType || 'done',
    keyboardType: props.keyboardType || 'phone-pad',
    placeholder: props.placeholder || 'Enter mobile number',
    placeholderTextColor: props.placeholderTextColor || '#3F00FF',
    editable: props.editable || true,
    multiline: props.multiline || false,
    autoCapitalize: props.autoCapitalize || 'none',
    autoFocus: props.autoFocus || false,
    blurOnSubmit: props.blurOnSubmit || false,
    enablesReturnKeyAutomatically: props.enablesReturnKeyAutomatically || false,
    onSubmitEditing: props.doneButton,
    onBlur: props.onBlur,
    onChange: props.onChange,
    onFocus: props.onFocus,
    returnKeyLabel: props.returnKeyLabel || 'default',
    secureTextEntry: props.secureTextEntry || false,
    textAlign: props.textAlign || 'left'
  })), props.button ? /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
    onPress: props.onPress,
    style: [styles.buttonView, props.ButtonViewStyle]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.buttonText, props.ButtonTextStyle]
  }, props.buttonText || 'Request OTP')) : null, props.SignupButton ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.title, {
      fontSize: 15,
      textAlign: 'center',
      marginTop: 30
    }, props.SignupTextStyle]
  }, props.SingupText || 'or continue with'), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: {
      flexDirection: 'row',
      alignItems: 'center',
      width: '70%',
      alignSelf: 'center',
      justifyContent: 'space-between',
      marginTop: 10
    }
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
    source: require('./a.jpeg'),
    style: [{
      height: 50,
      width: 50,
      borderRadius: 20
    }, props.SocialIconStyle]
  }), /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
    source: require('./a.jpeg'),
    style: [{
      height: 50,
      width: 50,
      borderRadius: 20
    }, props.SocialIconStyle]
  }), /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
    source: require('./a.jpeg'),
    style: [{
      height: 50,
      width: 50,
      borderRadius: 20
    }, props.SocialIconStyle]
  }))) : null)), props.modalVisible ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactNative.Modal, {
    animationType: "slide",
    transparent: true,
    visible: props.modalVisible,
    onRequestClose: () => {
      _reactNative.Alert.alert('Modal has been closed.');
      setModalVisible(!modalVisible);
    }
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.centeredView
  }, /*#__PURE__*/_react.default.createElement(_reactNative.KeyboardAvoidingView, {
    behavior: _reactNative.Platform.OS == 'android' ? 'height' : 'padding'
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.modalView
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.title, props.TextStyle]
  }, props.LoginTextOTP || 'Verify your OTP here'), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.inputContainer
  }, /*#__PURE__*/_react.default.createElement(_reactNative.TextInput, {
    onSubmitEditing: props.doneButton,
    maxLength: 6,
    onChangeText: props.onChangeTextOTP,
    value: props.valueOTP,
    style: [styles.input, props.InputBoxStyle],
    returnKeyType: props.returnKeyType || 'done',
    keyboardType: 'number-pad',
    placeholder: props.placeholderOTP || 'enter otp here... ',
    placeholderTextColor: props.placeholderTextColorOTP || 'grey',
    editable: props.editableOTP || true,
    multiline: false,
    autoCapitalize: 'none',
    autoFocus: props.autoFocusOTP || false,
    blurOnSubmit: props.blurOnSubmitOTP || false,
    enablesReturnKeyAutomatically: props.enablesReturnKeyAutomaticallyOTP || false,
    onBlur: props.onBlurOTP,
    onChange: props.onChangeOTP,
    onFocus: props.onFocusOTP,
    returnKeyLabel: props.returnKeyLabel || 'default',
    secureTextEntry: props.secureTextEntryOTP || true,
    textAlign: props.textAlign || 'left'
  })), props.ResendButton ? /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
    onPress: props.onPressOTP,
    style: [styles.buttonView, props.ButtonViewStyle]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.buttonText, props.ButtonTextStyle]
  }, props.buttonTextOTP || 'Continue')) : null, props.ResendButton ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.title, {
      fontSize: 15,
      textAlign: 'center',
      marginTop: 10
    }, props.SignupTextStyle]
  }, props.DontOTP || "Don't received an OTP yet? ", /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    disabled: timerCount == 0 ? false : true,
    onPress: props.ResendButtonClick,
    style: [{
      fontSize: 15,
      fontWeight: 'bold',
      color: timerCount == 0 ? 'black' : 'grey'
    }, props.SingupStyle]
  }, props.ResendOTP || 'Resend OTP')), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    onPress: props.SingupClick,
    style: [styles.title, {
      fontSize: 15,
      fontWeight: 'bold',
      textAlign: 'center'
    }, props.SingupStyle]
  }, '00 : ' + +timerCount)) : null))))) : null))));
};
const styles = _reactNative.StyleSheet.create({
  backgroundImage: {
    borderRadius: 10,
    resizeMode: 'cover'

    // or 'stretch' for a different background image behavior
  },

  viewa: {
    alignSelf: 'center',
    width: '90%',
    height: 'auto'
  },
  inputContainer: {
    flexDirection: 'row',
    alignItems: 'center',
    marginBottom: 10
  },
  buttonView: {
    height: 50,
    marginTop: 20,
    borderRadius: 10,
    backgroundColor: 'blue',
    justifyContent: 'center',
    // padding: 10,
    shadowColor: 'blue',
    shadowOffset: {
      width: 4,
      height: 4
    },
    elevation: 5,
    shadowRadius: 2,
    shadowOpacity: 0.6
  },
  buttonText: {
    textAlign: 'center',
    color: 'white',
    fontSize: 15,
    fontWeight: '600'
  },
  title: {
    fontSize: 25,
    color: 'black',
    marginBottom: 10
  },
  Logintitle: {
    fontSize: 20,
    color: 'black',
    fontWeight: 'bold',
    marginTop: 30
  },
  Texttitle: {
    fontSize: 18,
    color: 'black',
    marginBottom: 10,
    // fontWeight:'600',
    marginTop: 10
  },
  RegisterText: {
    fontSize: 15,
    color: 'black',
    marginBottom: 30,
    // fontWeight:'bold',
    marginTop: 20
  },
  input: {
    width: '100%',
    height: 50,
    backgroundColor: '#CCCCFF',
    paddingLeft: 10,
    // marginBottom: 10,
    padding: 10,
    shadowColor: '#000000',
    shadowOffset: {
      width: 1,
      height: 1
    },
    elevation: 5,
    shadowRadius: 2,
    shadowOpacity: 0.2,
    borderRadius: 10
  },
  centeredView: {
    flex: 1,
    justifyContent: 'flex-end',
    alignItems: 'center'
    // backgroundColor:'red',
  },

  modalView: {
    paddingTop: 10,
    paddingBottom: 10,
    justifyContent: 'center',
    width: '90%',
    // shadowColor: '#000',
    // shadowOffset: {
    //   width: 0,
    //   height: 2,
    // },
    // shadowOpacity: 0.25,
    // shadowRadius: 4,
    elevation: 5
  },
  button: {
    borderRadius: 20,
    padding: 10,
    elevation: 2
  },
  buttonOpen: {
    backgroundColor: '#F194FF'
  },
  buttonClose: {
    backgroundColor: '#2196F3'
  },
  textStyle: {
    color: 'white',
    fontWeight: 'bold',
    textAlign: 'center'
  },
  modalText: {
    marginBottom: 10,
    marginTop: 10,
    textAlign: 'left',
    width: '90%',
    alignSelf: 'center'
  }
});
var _default = exports.default = Sandy;
//# sourceMappingURL=index.js.map