import React, { useEffect, useState } from 'react';
import {
  KeyboardAvoidingView,
  Platform,
  SafeAreaView,
  Keyboard,
  Image,
  Alert,
  TouchableOpacity,
  View,
  Text,
  TextInput,
  StyleSheet,
  Modal
} from 'react-native';

interface BioProps {
  onChangeText: (params: any) => any;
  value: string;
  onPress: (params: any) => any;
  onBlur: (params: any) => any;
  onChange: (params: any) => any;
  onFocus: (params: any) => any;
  buttonText: string;
  source?: JSX.Element;
  keyboardType: any;
  input: any;
  editable: boolean;
  placeholder: string;
  multiline: boolean;
  autoCapitalize: any;
  returnKeyType: any;
  placeholderTextColor: string;
  numberOfLines: number;
  maxLength: number;
  autoFocus: boolean;
  blurOnSubmit: boolean;
  enablesReturnKeyAutomatically: boolean;
  returnKeyLabel: string;
  secureTextEntry: boolean;
  textAlign: any;
  ImageViewStyle: any;
  ContainerViewStyle: any;
  ImageStyle: any;
  MainView: any;
  TextStyle: any;
  InputBoxStyle: any;
  ButtonViewStyle: any;
  ButtonTextStyle: any;
  button: boolean;
  SignupButton: boolean;
  SignupTextStyle: any;
  SingupStyle: any;
  SingupText: string;
  Singup: string;
  SingupClick: (params: any) => any;
  Login: string;
  valueOTP: string;
  onChangeTextOTP: (params: any) => any;
  placeholderOTP: string;
  placeholderTextColorOTP: string;
  editableOTP: boolean;
  autoFocusOTP: boolean;
  blurOnSubmitOTP: boolean;
  enablesReturnKeyAutomaticallyOTP: boolean;
  onBlurOTP: (params: any) => any;
  onFocusOTP: (params: any) => any;
  onChangeOTP: (params: any) => any;
  secureTextEntryOTP: boolean;
  ResendOTP: string;
  DontOTP: string;
  ResendButton: boolean;
  buttonTextOTP: string;
  onPressOTP: (params: any) => any;
  ResendButtonClick: (params: any) => any;
  LoginTextOTP: string;
  modalVisible: boolean;
  doneButton: (params: any) => any;
  Texttitle: string;
  SocialIconStyle: any;
  RegisterText: string;
  RegisterTextStyle: any;
  TexttitleStyle: any;
}

const Sandy: React.FC<BioProps> = (props): JSX.Element => {
  const [isKeyboardVisible, setKeyboardVisible] = useState(false);
  const [modalVisible, setModalVisible] = useState(props.modalVisible || false);

  const [timerCount, setTimer] = useState(0);

  useEffect(() => {
    const keyboardDidShowListener = Keyboard.addListener(
      'keyboardDidShow',
      () => {
        setKeyboardVisible(true); // or some other action
      }
    );
    const keyboardDidHideListener = Keyboard.addListener(
      'keyboardDidHide',
      () => {
        setKeyboardVisible(false); // or some other action
      }
    );

    return () => {
      keyboardDidHideListener.remove();
      keyboardDidShowListener.remove();
    };
  }, []);

  useEffect(() => {
    timerValue();
  }, [props.modalVisible]);

  const timerValue = () => {
    if (props.modalVisible == true) {
      let timeval = 31;
      let testTime = setInterval(function () {
        setTimer(--timeval);
        if (timeval == 0) {
          clearInterval(testTime);
        }
      }, 1000);
    } else {
      console.log('not time');
    }
  };

  console.log('isKeyboardVisible', isKeyboardVisible);

  return (
    <>
      <SafeAreaView style={{ flex: 1 }}>
        <KeyboardAvoidingView
          behavior={Platform.OS == 'android' ? 'height' : 'padding'}
        >
          <View
            style={[
              {
                height: '100%',
                width: '100%',
                // justifyContent: 'center',
              },
              props.MainView,
            ]}
          >
            {props.source ? (
              <View
                style={[
                  {
                    // height: isKeyboardVisible ? '40%' : '60%',
                    width: '90%',
                    alignSelf: 'center',
                  },
                  props.ImageViewStyle,
                ]}
              >
                <Image
                  source={props.source ? props.source : require('./a.jpeg')}
                  style={[
                    styles.backgroundImage,
                    {
                      height: 50,
                      width: 230,
                    },
                    props.ImageStyle,
                  ]}
                />
              </View>
            ) : null}
            {props.modalVisible ? null : (
              <View style={[styles.viewa, props.ContainerViewStyle]}>
                <>
                  <Text style={[styles.Logintitle, props.TextStyle]}>
                    {props.Login || 'Login'}
                  </Text>
                  <Text style={[styles.Texttitle, props.TexttitleStyle]}>
                    {props.Texttitle ||
                      'Build your ideas into future ready digital apps'}
                  </Text>
                  <Text style={[styles.RegisterText, props.RegisterTextStyle]}>
                    {props.RegisterText ||
                      "If you don't have an account register, You can "}
                    <Text
                      style={[
                        styles.RegisterText,
                        props.RegisterTextStyle,
                        { color: 'blue', fontWeight: '600' },
                      ]}
                    >
                      Register here!
                    </Text>
                  </Text>
                  <View style={styles.inputContainer}>
                    <TextInput
                      numberOfLines={props.numberOfLines || 1}
                      maxLength={props.maxLength || 10}
                      onChangeText={props.onChangeText}
                      value={props.value}
                      style={[styles.input, props.InputBoxStyle]}
                      returnKeyType={props.returnKeyType || 'done'}
                      keyboardType={props.keyboardType || 'phone-pad'}
                      placeholder={props.placeholder || 'Enter mobile number'}
                      placeholderTextColor={
                        props.placeholderTextColor || '#3F00FF'
                      }
                      editable={props.editable || true}
                      multiline={props.multiline || false}
                      autoCapitalize={props.autoCapitalize || 'none'}
                      autoFocus={props.autoFocus || false}
                      blurOnSubmit={props.blurOnSubmit || false}
                      enablesReturnKeyAutomatically={
                        props.enablesReturnKeyAutomatically || false
                      }
                      onSubmitEditing={props.doneButton}
                      onBlur={props.onBlur}
                      onChange={props.onChange}
                      onFocus={props.onFocus}
                      returnKeyLabel={props.returnKeyLabel || 'default'}
                      secureTextEntry={props.secureTextEntry || false}
                      textAlign={props.textAlign || 'left'}
                    />
                  </View>
                  {props.button ? (
                    <TouchableOpacity
                      onPress={props.onPress}
                      style={[styles.buttonView, props.ButtonViewStyle]}
                    >
                      <Text style={[styles.buttonText, props.ButtonTextStyle]}>
                        {props.buttonText || 'Request OTP'}
                      </Text>
                    </TouchableOpacity>
                  ) : null}
                  {props.SignupButton ? (
                    <>
                      <Text
                        style={[
                          styles.title,
                          { fontSize: 15, textAlign: 'center', marginTop: 30 },
                          props.SignupTextStyle,
                        ]}
                      >
                        {props.SingupText || 'or continue with'}
                      </Text>
                      <View
                        style={{
                          flexDirection: 'row',
                          alignItems: 'center',
                          width: '70%',
                          alignSelf: 'center',
                          justifyContent: 'space-between',
                          marginTop: 10,
                        }}
                      >
                        <Image
                          source={require('./a.jpeg')}
                          style={[
                            {
                              height: 50,
                              width: 50,
                              borderRadius: 20,
                            },
                            props.SocialIconStyle,
                          ]}
                        />
                        <Image
                          source={require('./a.jpeg')}
                          style={[
                            {
                              height: 50,
                              width: 50,
                              borderRadius: 20,
                            },
                            props.SocialIconStyle,
                          ]}
                        />
                        <Image
                          source={require('./a.jpeg')}
                          style={[
                            {
                              height: 50,
                              width: 50,
                              borderRadius: 20,
                            },
                            props.SocialIconStyle,
                          ]}
                        />
                      </View>
                    </>
                  ) : null}
                </>
              </View>
            )}

            {props.modalVisible ? (
              <>
                <Modal
                  animationType="slide"
                  transparent={true}
                  visible={props.modalVisible}
                  onRequestClose={() => {
                    Alert.alert('Modal has been closed.');
                    setModalVisible(!modalVisible);
                  }}
                >
                  <View style={styles.centeredView}>
                    <KeyboardAvoidingView
                      behavior={Platform.OS == 'android' ? 'height' : 'padding'}
                    >
                      <View style={styles.modalView}>
                        <Text style={[styles.title, props.TextStyle]}>
                          {props.LoginTextOTP || 'Verify your OTP here'}
                        </Text>
                        <View style={styles.inputContainer}>
                          <TextInput
                            onSubmitEditing={props.doneButton}
                            maxLength={6}
                            onChangeText={props.onChangeTextOTP}
                            value={props.valueOTP}
                            style={[styles.input, props.InputBoxStyle]}
                            returnKeyType={props.returnKeyType || 'done'}
                            keyboardType={'number-pad'}
                            placeholder={
                              props.placeholderOTP || 'enter otp here... '
                            }
                            placeholderTextColor={
                              props.placeholderTextColorOTP || 'grey'
                            }
                            editable={props.editableOTP || true}
                            multiline={false}
                            autoCapitalize={'none'}
                            autoFocus={props.autoFocusOTP || false}
                            blurOnSubmit={props.blurOnSubmitOTP || false}
                            enablesReturnKeyAutomatically={
                              props.enablesReturnKeyAutomaticallyOTP || false
                            }
                            onBlur={props.onBlurOTP}
                            onChange={props.onChangeOTP}
                            onFocus={props.onFocusOTP}
                            returnKeyLabel={props.returnKeyLabel || 'default'}
                            secureTextEntry={props.secureTextEntryOTP || true}
                            textAlign={props.textAlign || 'left'}
                          />
                        </View>
                        {props.ResendButton ? (
                          <TouchableOpacity
                            onPress={props.onPressOTP}
                            style={[styles.buttonView, props.ButtonViewStyle]}
                          >
                            <Text
                              style={[styles.buttonText, props.ButtonTextStyle]}
                            >
                              {props.buttonTextOTP || 'Continue'}
                            </Text>
                          </TouchableOpacity>
                        ) : null}
                        {props.ResendButton ? (
                          <>
                            <Text
                              style={[
                                styles.title,
                                {
                                  fontSize: 15,
                                  textAlign: 'center',
                                  marginTop: 10,
                                },
                                props.SignupTextStyle,
                              ]}
                            >
                              {props.DontOTP || "Don't received an OTP yet? "}
                              <Text
                                disabled={timerCount == 0 ? false : true}
                                onPress={props.ResendButtonClick}
                                style={[
                                  {
                                    fontSize: 15,
                                    fontWeight: 'bold',
                                    color: timerCount == 0 ? 'black' : 'grey',
                                  },
                                  props.SingupStyle,
                                ]}
                              >
                                {props.ResendOTP || 'Resend OTP'}
                              </Text>
                            </Text>
                            <Text
                              onPress={props.SingupClick}
                              style={[
                                styles.title,
                                {
                                  fontSize: 15,
                                  fontWeight: 'bold',
                                  textAlign: 'center',
                                },
                                props.SingupStyle,
                              ]}
                            >
                              {'00 : ' + +timerCount}
                            </Text>
                          </>
                        ) : null}
                      </View>
                    </KeyboardAvoidingView>
                  </View>
                </Modal>
              </>
            ) : null}
          </View>
        </KeyboardAvoidingView>
      </SafeAreaView>
    </>
  );
};

const styles = StyleSheet.create({
  backgroundImage: {
    borderRadius: 10,

    resizeMode: 'cover',

    // or 'stretch' for a different background image behavior
  },
  viewa: {
    alignSelf: 'center',
    width: '90%',
    height: 'auto',
  },
  inputContainer: {
    flexDirection: 'row',
    alignItems: 'center',
    marginBottom: 10,
  },

  buttonView: {
    height: 50,
    marginTop: 20,
    borderRadius: 10,
    backgroundColor: 'blue',
    justifyContent: 'center',
    // padding: 10,
    shadowColor: 'blue',
    shadowOffset: {
      width: 4,
      height: 4,
    },
    elevation: 5,
    shadowRadius: 2,
    shadowOpacity: 0.6,
  },
  buttonText: {
    textAlign: 'center',
    color: 'white',
    fontSize: 15,
    fontWeight: '600',
  },
  title: {
    fontSize: 25,
    color: 'black',
    marginBottom: 10,
  },
  Logintitle: {
    fontSize: 20,
    color: 'black',
    fontWeight: 'bold',
    marginTop: 30,
  },
  Texttitle: {
    fontSize: 18,
    color: 'black',
    marginBottom: 10,
    // fontWeight:'600',
    marginTop: 10,
  },
  RegisterText: {
    fontSize: 15,
    color: 'black',
    marginBottom: 30,
    // fontWeight:'bold',
    marginTop: 20,
  },

  input: {
    width: '100%',
    height: 50,
    backgroundColor: '#CCCCFF',
    paddingLeft: 10,
    // marginBottom: 10,
    padding: 10,
    shadowColor: '#000000',
    shadowOffset: {
      width: 1,
      height: 1,
    },
    elevation: 5,
    shadowRadius: 2,
    shadowOpacity: 0.2,

    borderRadius: 10,
  },
  centeredView: {
    flex: 1,
    justifyContent: 'flex-end',
    alignItems: 'center',
    // backgroundColor:'red',
  },
  modalView: {
    paddingTop: 10,
    paddingBottom: 10,
    justifyContent: 'center',
    width: '90%',
    // shadowColor: '#000',
    // shadowOffset: {
    //   width: 0,
    //   height: 2,
    // },
    // shadowOpacity: 0.25,
    // shadowRadius: 4,
    elevation: 5,
  },
  button: {
    borderRadius: 20,
    padding: 10,
    elevation: 2,
  },
  buttonOpen: {
    backgroundColor: '#F194FF',
  },
  buttonClose: {
    backgroundColor: '#2196F3',
  },
  textStyle: {
    color: 'white',
    fontWeight: 'bold',
    textAlign: 'center',
  },
  modalText: {
    marginBottom: 10,
    marginTop: 10,
    textAlign: 'left',
    width: '90%',
    alignSelf: 'center',
  },
});

export default Sandy;
